Package com.arms.api.util.communicate.external

## Interface AggregationService

-     @FeignClient(name="engine-dashboard",
                   url="${arms.engine.url}")
      public interface AggregationService

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `org.springframework.http.ResponseEntity<java.util.Map<java.lang.String,​RequirementJiraIssueAggregationResponse>>` | `aggregateWeeklyReqIssueStatus​(DashboardDTO dashboardDTO)` |
    `org.springframework.http.ResponseEntity<java.util.List<CostVO>>` | `aggregationByAssigneeAccountId​(CostDTO costDTO)` |
    `org.springframework.http.ResponseEntity<java.util.List<CostVO>>` | `aggregationByReqLinkAndAssigneeAccountId​(CostDTO costDTO)` |
    `java.util.List<AssigneeTimeDiffVO>` | `calculateWorkdayByAccountId​(CostDTO costDTO)` |
    `org.springframework.http.ResponseEntity<java.util.List<TreemapExcelVO>>` | `findAssigneeRequirementInvolvementData​(ResourceWithVersionIdNamesDTO resourceWithVersionIdNamesDTO)` |
    `org.springframework.http.ResponseEntity<java.util.List<UniqueAssigneeVO>>` | `findAssigneesInfo​(ResourceDTO resourceDTO)` |
    `java.util.List<HorizontalBarChartYAxisAndSeriesVO>` | `findHorizontalBarChartData​(ResourceDTO resourceDTO)` |
    `ReqAndNotReqHorizontalBarChartVO` | `findHorizontalBarChartDataBySameAccounts​(ResourceDTO resourceDTO)` |
    `ReqAndNotReqPieChartVO` | `findPieChartData​(ResourceDTO resourceDTO)` |
    `TotalIssueAndPieChartVO` | `findPieChartDataExpand​(ResourceDTO resourceDTO)` |
    `org.springframework.http.ResponseEntity<java.util.List<TreeMapWorkerVO>>` | `findTreeMapChartDataV3​(ResourceWithVersionIdNamesDTO resourceWithVersionIdNamesDTO)` |
    `java.util.List<SankeyChartBaseVO>` | `findVersionAssigneeSummaryData​(ResourceDTO resourceDTO)` |
    `org.springframework.http.ResponseEntity<java.util.List<CostVO>>` | `getAssigneeList​(CostDTO costDTO)` | 총 4depth 까지의 nested aggregation 처리 pdServiceVersions > isReq > assignee_accountId > assignee_displayName
    `org.springframework.http.ResponseEntity<java.util.List<CostVO>>` | `getAssigneeListByProductVersionAndRequirement​(CostDTO costDTO)` |
    `java.util.List<CircularPackingChartVO>` | `getCircularPackingChartData​(ScopeDTO scopeDTO)` |
    `java.util.List<ReqDataTableIssuesVO>` | `getDataTableIssues​(ScopeDTO scopeDTO)` |
    `java.util.List<IssueVO>` | `getIssueList​(ScopeDTO scopeDTO)` |
    `org.springframework.http.ResponseEntity<java.util.List<AlmIssueStatVO>>` | `getMultiCombinationChartData​(TimeDTO timeDTO)` |
    `java.util.List<NetworkChartExcelDataVO>` | `getNetworkChartExcelData​(ScopeDTO scopeDTO)` |
    `java.util.List<PdServiceVersionsAndReqVO>` | `getPdServiceVersionsAndReq​(ScopeDTO scopeDto)` |
    `org.springframework.http.ResponseEntity<java.util.List<RidgeLineVO>>` | `getRidgeLineData​(TimeDTO timeDTO)` |
    `org.springframework.http.ResponseEntity<java.util.List<AlmIssue>>` | `getUpdatedIssueByDateRange​(TimeDTO timeDTO)` |
    `java.util.List<IssueVO>` | `getVersionsAndIssueList​(ScopeDTO scopeDTO)` |
    `java.util.List<UniqueAssigneeIssueStatusVO>` | `issueStatusDataByAssignee​(ResourceDTO resourceDTO)` |
    `StackedHorizontalBarChartVO` | `issueStatusStackedBarChartData​(ResourceDTO resourceDTO)` |
    `org.springframework.http.ResponseEntity<ReqAndIssueTotalCountVO>` | `topMenuTotalCountWithReqAndSubtask​(TopMenuAnalysisDTO topMenuAnalysisDTO)` |
    `java.util.List<TopNReqAssigneeReqLinkVO>` | `topNAssigneeReqLinks​(DashboardDTO dashboardDTO, java.lang.Integer topN)` |
    `java.util.List<TopNReqAssigneeVO>` | `topNReqAssignee​(DashboardDTO dashboardDTO, java.lang.Integer topN)` |
    `org.springframework.http.ResponseEntity<java.util.List<TreeBarIssueVO>>` | `treeBarData​(ScopeDTO scopeDTO)` |
    `java.util.List<WordCloudExcelVO>` | `wordCloudData​(ResourceDTO resourceDTO)` |
    `org.springframework.http.ResponseEntity<java.util.List<ReqProgressVO>>` | `제품서비스_일반_버전_해결책유무_통계_V2​(ReqAnalysisDTO reqAnalysisDTO, java.lang.String resolution)` |

- - ### Method Detail

    - #### aggregateWeeklyReqIssueStatus

          @PostMapping("/engine/dashboard/aggregate-weekly-req-issue-status")
          org.springframework.http.ResponseEntity<java.util.Map<java.lang.String,​RequirementJiraIssueAggregationResponse>> aggregateWeeklyReqIssueStatus​(@RequestBody
                                                                                                                                                               DashboardDTO dashboardDTO)

    - #### topNReqAssignee

          @PostMapping("/engine/dashboard/top-req-assignee")
          java.util.List<TopNReqAssigneeVO> topNReqAssignee​(@RequestBody
                                                            DashboardDTO dashboardDTO,
                                                            @RequestParam
                                                            java.lang.Integer topN)

    - #### topNAssigneeReqLinks

          @PostMapping("/engine/dashboard/top-req-assignee-links")
          java.util.List<TopNReqAssigneeReqLinkVO> topNAssigneeReqLinks​(@RequestBody
                                                                        DashboardDTO dashboardDTO,
                                                                        @RequestParam
                                                                        java.lang.Integer topN)

    - #### 제품서비스_일반_버전_해결책유무_통계_V2

          @PostMapping("/engine/req-gantt/resolution")
          org.springframework.http.ResponseEntity<java.util.List<ReqProgressVO>> 제품서비스_일반_버전_해결책유무_통계_V2​(@RequestBody
                                                                                                         ReqAnalysisDTO reqAnalysisDTO,
                                                                                                         @RequestParam
                                                                                                         java.lang.String resolution)

    - #### aggregationByAssigneeAccountId

          @PostMapping("/engine/analysis-cost/aggregation/assignee-account-id")
          org.springframework.http.ResponseEntity<java.util.List<CostVO>> aggregationByAssigneeAccountId​(@RequestBody
                                                                                                         CostDTO costDTO)

    - #### aggregationByReqLinkAndAssigneeAccountId

          @PostMapping("/engine/analysis-cost/aggregation/assignee-account-id-and-req-link")
          org.springframework.http.ResponseEntity<java.util.List<CostVO>> aggregationByReqLinkAndAssigneeAccountId​(@RequestBody
                                                                                                                   CostDTO costDTO)

    - #### getAssigneeList

          @PostMapping("/engine/analysis-cost/assignee-list")
          org.springframework.http.ResponseEntity<java.util.List<CostVO>> getAssigneeList​(@RequestBody
                                                                                          CostDTO costDTO)

      총 4depth 까지의 nested aggregation 처리 pdServiceVersions > isReq > assignee_accountId > assignee_displayName

    - #### getAssigneeListByProductVersionAndRequirement

          @PostMapping("/engine/analysis-cost/version-requirement/assignee-list")
          org.springframework.http.ResponseEntity<java.util.List<CostVO>> getAssigneeListByProductVersionAndRequirement​(@RequestBody
                                                                                                                        CostDTO costDTO)

    - #### calculateWorkdayByAccountId

          @PostMapping("/engine/analysis-cost/calculateWorkdayByAccountId")
          java.util.List<AssigneeTimeDiffVO> calculateWorkdayByAccountId​(@RequestBody
                                                                         CostDTO costDTO)

    - #### wordCloudData

          @PostMapping("/engine/analysis-resource/word-cloud-data")
          java.util.List<WordCloudExcelVO> wordCloudData​(@RequestBody
                                                         ResourceDTO resourceDTO)

    - #### issueStatusStackedBarChartData

          @PostMapping("/engine/analysis-resource/issue-status-stacked-bar")
          StackedHorizontalBarChartVO issueStatusStackedBarChartData​(@RequestBody
                                                                     ResourceDTO resourceDTO)

    - #### findPieChartData

          @PostMapping("/engine/analysis-resource/top-contributors/pie")
          ReqAndNotReqPieChartVO findPieChartData​(@RequestBody
                                                  ResourceDTO resourceDTO)

    - #### findPieChartDataExpand

          @PostMapping("/engine/analysis-resource/top-contributors/pie-expand")
          TotalIssueAndPieChartVO findPieChartDataExpand​(@RequestBody
                                                         ResourceDTO resourceDTO)

    - #### findHorizontalBarChartData

          @PostMapping("/engine/analysis-resource/top-contributors/horizontal-bar")
          java.util.List<HorizontalBarChartYAxisAndSeriesVO> findHorizontalBarChartData​(@RequestBody
                                                                                        ResourceDTO resourceDTO)

    - #### findHorizontalBarChartDataBySameAccounts

          @PostMapping("/engine/analysis-resource/top-contributors/horizontal-bar-at-once")
          ReqAndNotReqHorizontalBarChartVO findHorizontalBarChartDataBySameAccounts​(@RequestBody
                                                                                    ResourceDTO resourceDTO)

    - #### issueStatusDataByAssignee

          @PostMapping("/engine/analysis-resource/issue-status-by-assignee")
          java.util.List<UniqueAssigneeIssueStatusVO> issueStatusDataByAssignee​(@RequestBody
                                                                                ResourceDTO resourceDTO)

    - #### findVersionAssigneeSummaryData

          @PostMapping("/engine/analysis-resource/version-assignee-summary")
          java.util.List<SankeyChartBaseVO> findVersionAssigneeSummaryData​(@RequestBody
                                                                           ResourceDTO resourceDTO)

    - #### findAssigneesInfo

          @PostMapping("/engine/analysis-resource/assignees-info")
          org.springframework.http.ResponseEntity<java.util.List<UniqueAssigneeVO>> findAssigneesInfo​(@RequestBody
                                                                                                      ResourceDTO resourceDTO)

    - #### findTreeMapChartDataV3

          @PostMapping("/engine/analysis-resource/assignees-requirements-involvements-v3")
          org.springframework.http.ResponseEntity<java.util.List<TreeMapWorkerVO>> findTreeMapChartDataV3​(@RequestBody
                                                                                                          ResourceWithVersionIdNamesDTO resourceWithVersionIdNamesDTO)

    - #### findAssigneeRequirementInvolvementData

          @PostMapping("/engine/analysis-resource/assignees-requirements-involvement-data")
          org.springframework.http.ResponseEntity<java.util.List<TreemapExcelVO>> findAssigneeRequirementInvolvementData​(@RequestBody
                                                                                                                         ResourceWithVersionIdNamesDTO resourceWithVersionIdNamesDTO)

    - #### treeBarData

          @PostMapping("/engine/analysis-scope/tree-bar-data-v2")
          org.springframework.http.ResponseEntity<java.util.List<TreeBarIssueVO>> treeBarData​(@RequestBody
                                                                                              ScopeDTO scopeDTO)

    - #### getPdServiceVersionsAndReq

          @PostMapping("/engine/analysis-scope/getPdServiceVersionsAndReq")
          java.util.List<PdServiceVersionsAndReqVO> getPdServiceVersionsAndReq​(ScopeDTO scopeDto)

    - #### getVersionsAndIssueList

          @PostMapping("/engine/analysis-scope/getVersionsAndIssueList")
          java.util.List<IssueVO> getVersionsAndIssueList​(@RequestBody
                                                          ScopeDTO scopeDTO)

    - #### getIssueList

          @PostMapping("/engine/analysis-scope/getIssueList")
          java.util.List<IssueVO> getIssueList​(@RequestBody
                                               ScopeDTO scopeDTO)

    - #### getNetworkChartExcelData

          @PostMapping("/engine/analysis-scope/getNetworkChartExcelData")
          java.util.List<NetworkChartExcelDataVO> getNetworkChartExcelData​(@RequestBody
                                                                           ScopeDTO scopeDTO)

    - #### getCircularPackingChartData

          @PostMapping("/engine/analysis-scope/circular-packing-data")
          java.util.List<CircularPackingChartVO> getCircularPackingChartData​(@RequestBody
                                                                             ScopeDTO scopeDTO)

    - #### getDataTableIssues

          @PostMapping("/engine/analysis-scope/getDataTableIssues")
          java.util.List<ReqDataTableIssuesVO> getDataTableIssues​(@RequestBody
                                                                  ScopeDTO scopeDTO)

    - #### getMultiCombinationChartData

          @PostMapping("/engine/analysis-time/updated-issue/multi-combination-data")
          org.springframework.http.ResponseEntity<java.util.List<AlmIssueStatVO>> getMultiCombinationChartData​(@RequestBody
                                                                                                               TimeDTO timeDTO)

    - #### getUpdatedIssueByDateRange

          @PostMapping("/engine/analysis-time/updated-timeline")
          org.springframework.http.ResponseEntity<java.util.List<AlmIssue>> getUpdatedIssueByDateRange​(@RequestBody
                                                                                                       TimeDTO timeDTO)

    - #### getRidgeLineData

          @PostMapping("/engine/analysis-time/updated-ridgeline")
          org.springframework.http.ResponseEntity<java.util.List<RidgeLineVO>> getRidgeLineData​(@RequestBody
                                                                                                TimeDTO timeDTO)

    - #### topMenuTotalCountWithReqAndSubtask

          @PostMapping("/engine/analysis-top-menu/totalCountWithReqAndSubtask")
          org.springframework.http.ResponseEntity<ReqAndIssueTotalCountVO> topMenuTotalCountWithReqAndSubtask​(@RequestBody
                                                                                                              TopMenuAnalysisDTO topMenuAnalysisDTO)